%ext ck5
%version 1.4
# Load the modified graphics
%egahead EGAHEAD.CK5
%patchfile $25B22 keen5.tli 
%maphead maphead.ck5
%gamemaps editmaps.ck5


##################################
# Change teleporter tile literal #
##################################

# The teleporter tile is in a different location from the default tile in the tileset
%patch $D54C $0A8FW


########################
# Shikadi Mine = sound #
########################

%patch $32948 $017AW $017AW $0001W $0000W $0000W $0014W $0000W $0000W
              $11C4036ARL   $00000000L    $090B17B5RL   $2608W 

#new mine sit code =play sound
%patch $11FAA $55 $8B $EC $B8 $0005W  $50 $9A $196E09EFRL     $83 $C4 $02
             $5D $CB


########
# Keen #
########

#Keen doesn't use special 'stand on Platforms' action
%patch $AE2D $EB
%patch $AF6F $EB

%patch $5CA1 $6F56W $0000W #Ammo (0)
#%patch $DC9D $EB $12 #Keen can always shoot, don't lose ammo

#Ignore elevators entirely (Don't place their starts in map level, or take notice of when fuse levels are done OR keen's map pos
%patch $F431 $90 $90

%patch $30C3E $0888W #no boring animation


#Don't lose V card on starting a level
%patch $6A2B $EB $04

#Rewrite HandleInput to take not pogo without Keycard
%patch $8ABF $3B
%patch $8AB8 $42
%patch $8AF1 $75 $06 $C7 $06 $BC27W  $0000W  $5D $CB $83 $3E $BC37W  $00 $75
             $0A $83 $3E $332CW  $00 $75 $03 $E9 $008BW  $83 $3E $9E2EW  $00
             $74 $1D $83 $3E $9E30W  $00 $74 $16 $C7 $06 $BC29W  $0001W  $33
             $C0 $A3 $BC2BW  $A3 $BC2FW  $A3 $BC2DW  $A3 $BC31W  $5D $CB $33
             $C0 $A3 $BC27W  $A3 $BC29W  $83 $3E $9E2EW  $00 $74 $08 $C7 $06
             $BC31W  $0001W  $EB $08 $33 $C0 $A3 $BC2FW  $A3 $BC31W  $83 $3E
             $9E30W  $00 $74 $22 $83 $3E $6F5AW  $00 $74 $19 $83 $3E $9E59W
             $08 $7F $0C $A1 $9E59W  $03 $06 $9BB4W  $A3 $9E59W  $5D $CB $C7
             $06 $BC2DW  $0001W  $5D $CB $83 $3E $9E59W  $00 $74 $08 $C7 $06
             $BC2DW  $0001W  $EB $08 $33 $C0 $A3 $BC2BW  $A3 $BC2DW  $C7 $06
             $9E59w  $0000W  $5D $CB $A1 $9E2EW  $A3 $BC31W  $A1 $9E30W  $83
             $3E $6F5AW  $00 $74 $03 $A3 $BC2DW  $A0 $38 $03 $B4 $00 $D1 $E0
             $8B $D8 $8B $87 $BCAFW  $A3 $BC29W  $33 $C0 $83 $3E $BC31W  $00
             $75 $03 $A3 $BC2FW  $83 $3E $BC2DW  $00 $75 $03 $A3 $BC2BW  $83
             $3E $BC29W  $00 $75 $03 $A3 $BC27W  $5D $CB
#K1n9_Duk3 note: this does NOT disable the pogo button on the gamepad!


#1Up Tile is now Ice => Keen slides
%patch $C58B $1A1BW
%patch $C50B $81 $7C $1C $0888W  $75 $05 $C7 $44 $1C $0F72W  $EB $18


#########
# Items #
#########

%patch $32754 $23BCW ##Smashed Slicestar not Vanish
#K1n9_Duk3 note: bouncing slicestar will turn into h/v slicestar!

%patch $C3E3 $19DCW #Vitalin got 1
%patch $3160E $11     
%patch $C373 $11     #Get Vitalin sound


#Volte-Face 1 = Battery
%patch $3200C $01A1W $01A1W $0001W $0000W $0000W $0014W $0000W $0000W
              $00000000L   $11C40456RL    $090B17B5RL   $1CEAW 

#Volte-Face 2
%patch $3202A $01A2W $01A2W $0001W $0000W $0000W $0014W $0000W $0000W
              $00000000L   $11C40456RL    $090B17B5RL   $1CCCW


%patch $12AB2 $0000W #Shikadi Master Spawn height

%patch $31A2E $0181W #Master cache start
%patch $31A82 $0182W #Cache end

#Shikadi Master 1= Schnaps
%patch $32E34 $0181W $0181W $0001W $0000W $0000W $0014W $0000W $0000W
              $00000000L   $11C40456RL   $090B17B5RL   $2B12W 

#Shikadi Master 2
%patch $32E52 $0182W $0182W $0001W $0000W $0000W $0014W $0000W $0000W
              $00000000L   $11C40456RL  $090B17B5RL   $2AF4W


#Shikadi MAster 3= item vanish
%patch $32E70 $01A5W $01A5W $0001W $0000W $0000W $0001W $0000W $0000W
              $00000000L   $00000000L    $00000000L   $0000W

#New Fragment collision -> vanish
%patch $12096	 $55 $8B $EC $56 $8B $76 $08 $83 $3C $02 $75 $0F
              $B8 $2B30W  $50 $FF $76 $06 $9A $090B1242RL    $83 $C4 $04
              $5E $5D $CB
#K1n9_Duk3 fix: removed the call to Keen's idle think function. it's usless
#and the call didn't pass the required parameters, which might have caused
#problems.


###########################
# Spindred - Falling Rock #
###########################

#Spindred foreground variable
%patch $128BB $0001W

#Volte-face foreground variable
%patch $10AFA $0001W


#Spindred sprite type
%patch $128B1 $0006W

#Cache
%patch $31A9A $01A8W #Spindred Cache end,only 1frame

#Spindred has Volte-Face Collision. Shot Volte-Face becomes Spindred2
%patch $10DE0 $2A9AW



%patch $32DBC $01A8W $01A8W $0001W $0000W $0000W $0000W $0000W $0000W
              $00000000L    $0F92149DRL $090B17B5RL   $2A7CW

%patch $32DDA $01A8W $01A8W $0003W $0000W $0000W $0000W $0000W $0000W
              $090B1710RL    $00000000L $0F920119RL   $2A9AW


######################
# Ampton - Cave Garg #
######################

#Sounds
%patch $112DB $EB     #Don't play Little Ampton walk sound 1
%patch $112F0 $EB     #Don't play Little Ampton walk sound 2


#spawn hight
%patch $11290 $FD60W #1/2 tile up

#Animations
#Ampton flip switch

%patch $32648 $0199W $0199W
%patch $32652 $000CW        #Animation speed

%patch $32666 $019BW $019BW
%patch $32670 $0020W        #Animation speed

%patch $32684 $019AW $019AW
%patch $3268E $0020W        #Animation speed

%patch $326A2 $019BW $019BW
%patch $326AC $0020W        #Animation speed

%patch $326C0 $019AW $019AW
%patch $326CA $0020W        #Animation speed

%patch $326DC $2254W

#Ampton takes 5 hits to kill (By Lemm)
%patch $11635 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09
              $9A $0AAF1517RL     $5F $5E $5D $CB
                                                  $83 $3D $03 $75 $F7 $FF $4C #New Stuff STarts here
              $40 $83 $7C $40 $FB $7F $1B $B8 $16 $00 $50 $9A $196E09EFRL     #Hits = 5 ($FB)
              $44 $44 $B8 $9E $23 $50 $57 $56 $9A $090B16CDRL     $83 $C4 $06 #Change sound to 16
              $EB $D3 $C7 $44 $42 $01 $00 $57 $9A $0CCB10B3RL     $44 $44 $EB
              $EF
%patch $1170D $EA $11C415CDRL


#################################
# Shockshund Vorticon Commander #
#################################

#Shot Animation
%patch $33302 $0192W $0192W

#Shocksund's shot same sprite
%patch $33300 $2FA4W


#smash
%patch $33320 $0192W $0192W
%patch $3333E $0192W $0192W

#Shocksund strength -99
%patch $1328A $0063W

#Shocksund's collision -now includes Spindred =$11C40CDBRL
%patch $1291B $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $05
              $9A $0AAF1517RL

                                  $83 $3D $03 $75 $38 $FF $4C $40 $75 $1C $C7
              $44 $16 $0000W  $C7 $44 $18 $0000W  $B8 $301CW  $50 $57 $56 $9A
              $090B16CDRL     $83 $C4 $06 $5F $5E $5D $CB
                                                          $C7 $44 $42 $0002W
              $C7 $44 $04 $0001W  $57 $9A $0CCB10B3RL     $83 $C4 $02 $5F $5E
              $5D $CB

                      $81 $7D $1C $2A9AW  $75 $0F $C7 $44 $16 $0000W  $C7 $44
              $18 $0000W  $C7 $44 $1C $301CW  $5F $5E $5D $CB

#Shocsund use new collision -sit
%patch $331EA $11C40CDBRL
%patch $33208 $11C40CDBRL

#Bark
%patch $33226 $11C40CDBRL
%patch $33244 $11C40CDBRL

#Walk
%patch $33262 $11C40CDBRL
%patch $33280 $11C40CDBRL
%patch $3329E $11C40CDBRL
%patch $332BC $11C40CDBRL

#Jump
%patch $332DA $11C40CDBRL

%patch $33374 $00000000L #Stunned



#Tile interaction (do not jumpon edges)
#Sit
%patch $331EE $090B17DCRL #Shocksund
%patch $3320C $090B17DCRL #Shocksund

#Bark
%patch $3322A $090B17DCRL #Shocksund
%patch $33248 $090B17DCRL #Shocksund

#Walk
%patch $33266 $090B17DCRL #Shocksund
%patch $33284 $090B17DCRL #Shocksund
%patch $332A2 $090B17DCRL #Shocksund
%patch $332C0 $090B17DCRL #Shocksund


#Jump frequency
%patch $132C9 $00
%patch $132EF $2ED2W

#Animations
#Shocksund bark
%patch $3321C $0018W        #Animation speed
%patch $3323A $0008W        #Animation speed

#Spawn hight
#Shot Spawn height
%patch $13357 $FFD0W #Vertical

#%patch $126CE $0000W #2 tiles down from sprite top
#%patch $3321C $0020W

##############
# Ice Cannon #
##############

#Shoot smash behaviour
%patch $32202 $11C40783RL #Shikadi Mine explode

#Shikadi Mine fragments collision
%patch $32A6A $00000000L

#Mine fragments animations
%patch $32A56 $00EDW $00EDW
#shot smash animation speed
%patch $321FC $0005W  
%patch $3221A $0005W      

#Ice Cannon Bulletts have only 1 animation
%patch $3217A $00ECW $00ECW $0003W $0000W $0000W $0040W $0000W $0000W
              $090B1748RL   $0F921689RL   $0F9216ACRL   $1E3AW 

#Shots move diagonally upwards
%patch $10F58 $8B $1E $40 $9E $C7 $47 $16 $FFC0W $EB $16 #Left move upwards
              $8B $1E $40 $9E $C7 $47 $18 $0040W $EB $14
              $8B $1E $40 $9E $C7 $47 $16 $0040W $90 $90 #Right moves upwards
              $8B $1E $40 $9E $C7 $47 $18 $FFC0W

#Directions shots are spawned:
%patch $10FA1 $1659W #Up (At $10F79)
              $164EW #Right (At $10F6E)
              $1643W #Down (At $10F63)
              $1638W #Left (At $10F58)

#Shots use transform code
%patch $10FB6 $11C40E86RL

#Custom collision: Transform

%patch $12AC6 $55 $8B $EC $83 $3E $BC91W  $00 $75 $34 $B8 $014DW  $50 $FF
             $36 $3E $9E $9A $090B1242RL     $83 $C4 $04 $B8 $001BW  $50 #Stun sound
             $9A $196E09EFRL     $83 $C4 $02 $8B $1E $3E $9E $C7 $47 $18
             $FFD0W  $C7 $47 $16 $0010W          #Stunned Keen speeds
             $C7 $47 $06 $0001W  $C7 $47 $20 $0001w	#K1n9_Duk3 fix: reset clipping and priority
             $5D $CB

#Keen stunned action =$0B94W
#%patch $30ED4 $008CW $008CW $0003W $0000W $0000W $0190W $0000W $0000W
#              $090B1710RL   $0AAF1597RL   $090B17B5RL   $0888W

%patch $3048D $008EW $008EW $0003W $0000W $0000W $00A0W $0000W $0000W
              $090B1710RL   $0AAF1597RL   $090B17B5RL   $0900W #Stunned Keen action (Read book type) =$014DW

%patch $30C40 $007FW $007FW $0003W $0000W $0000W $0040W $0000W $0000W
              $090B1710RL   $0AAF1597RL   $090B17B5RL   $0888W #Stunned Keen 2

#Keen can die while stunned
%patch $C021 $90 $90


###############
# Korath Yorp #
###############

%patch $31AA4 $0133W # Korath Cache end four extra sprites

# 3 new Standing animations. From Spirougrip
%patch $334A6 $298CW # normal standing goes to spirogrip spin5
%patch $32CCC $0130W $0130W  $0000W       $0000W $0001W        $001EW       $0000W   $0000W
              $00000000L     $037D0520RL  $090B17DCRL          $29AAW

%patch $32CEA $012EW $012EW  $0000W       $0000W $0001W        $001EW       $0000W   $0000W
              $00000000L     $037D0520RL  $090B17DCRL          $29C8W

%patch $32D08 $0131W $0131W  $0000W       $0000W $0001W        $001EW       $0000W   $0000W
              $00000000L     $037D0520RL  $090B17DCRL          $30D2W

#Korath uses new collision
%patch $33426 $037D0520RL
%patch $33444 $037D0520RL
%patch $33462 $037D0520RL
%patch $33480 $037D0520RL
%patch $3349E $037D0520RL

#Disable EGAGRAPH check in Keen 5 (Frees 389 bytes at $3CF0)
%patch $3CDF $90 $90

#New collision, stunnable, shootable, pushes Keen =$037D0520RL
%patch $3CF0 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $83 $3C $02 $75 $49 #React to Keen
             $81 $7C $1C $0FEAW  $72 $29 $81 $7C $1C $11ACW  $77 $22 $B8     #Check Keen in air
         $2662W  $50 $57 $9A $090B1242RL     $83 $C4 $04 $B8 $0024W  $50 $9A
             $196E09EFRL     $83 $C4 $02 $C7 $45 $3E $0000W  $5F $5E $5D $CB
             $8B $5C $1C $8B $47 $14 $0B $47 $16 $74 $0E $57 $56 $9A
     $090B0CD2RL     $83 $C4 $04 $5F $5E $5D $CB $83 $3C $03 $75 $0E $B8     #Push Keen, react to Keen's shot
         $3168W  $50 $56 $57 $9A $090B16CDRL     $83 $C4 $06 $5F $5E $5D $CB #Be stunned
#K1n9_Duk3 TODO: use PushContact instead of ClipToSpriteSide

#Stunned collision -can't be restunned or push Keen, just shot =$037D0590RL
%patch $3D60 $55 $8B $EC $56 $57 $8B $7E $06 $8B $76 $08 $EB $DC

#Stunned Yorp behavior, count up to unstunning =$037D059DRL
%patch $3D6D $55 $8B $EC $56 $8B $76 $06 $FF $44 $3E $8B $44 $3E $3D $0014W
             $72 $05 $C7 $44 $1C $29E6W  $5E $5D $CB

#Last stunned yorp
%patch $32D26 $0133W $0133W $0002W      $0000W $0000W $000EW   $0000W $0000W
              $090B1710RL    $037D0590RL $11C40BAARL   $298CW

%patch $127EA $55 $8B $EC $56 $8B $76 $06 $83 $7C $38 $00 $75 $06 $83 $7C $3C
             $00 $74 $05 $C7 $44 $16 $0000W  $83 $7C $3A $00 $74 $05 $C7 $44
             $18 $0000W  $83 $7C $36 $00 $74 $28 $C7 $44 $18 $0000W  $8B $5C
             $1C $83 $7F $1C $00 $74 $0E $FF $77 $1C $56 $9A $090B1242RL   
             $83 $C4 $04 $EB $0C $56 $9A $06B91E47RL     $83 $C4 $02 $5E $5D
             $CB
                 $FF $74 $20 $33 $C0 $50 $FF $74 $1E $FF $74 $0C $FF $74 $0A
             $8B $C6 $05 $46 $00 $50 $9A $174E163ERL     $83 $C4 $0C $5E $5D
             $CB


#Stunned Yorp loop
%patch $329A2 $0132W $0132W $0000W      $0000W $0000W $000EW   $0000W $0000W
              $037D059DRL   $037D0590RL $0F920119RL   $2680W
%patch $329C0 $0133W $0133W $0000W      $0000W $0000W $000EW   $0000W $0000W
              $037D059DRL   $037D0590RL $0F920119RL   $2662W


#########################
# Spirogrip =Tank Robot #
#########################

#spawn hight
%patch $127CC $FEEFW #1 tile 2 pixels up
%patch $125C7 $FEEFW #Spawn height RR

#Robo Red pushes Keen instead of killing him
%patch $12693 $83 $3D $02 $75 $F7 $56 $57 $9A $090B0CD2RL     $EB $EB
#Change other collisions to not kill Keen
%patch $32AA6 $11C40A0DRL #Pause before shooting
%patch $32AC4 $11C40A0DRL #Pause between shots
%patch $32AE2 $11C40A0DRL #Shooting

#Spawn Spirogrip
%patch $127DC $2914W

%patch $32C54 $018DW $0189W  $0000W       $0000W $0001W        $0006W       $0040W   $0000W
               $11C409BCRL $11C40A0DRL  $090B17DCRL       $2932W

%patch $32C72 $018EW $018AW  $0000W       $0000W $0001W        $0006W       $0040W   $0000W
               $11C409BCRL $11C40A0DRL  $090B17DCRL       $2950W 

%patch $32C90 $018FW $018BW  $0000W       $0000W $0001W        $0006W       $0040W   $0000W
               $11C409BCRL $11C40A0DRL  $090B17DCRL       $296EW

%patch $32CAE $0190W $018CW  $0000W       $0000W $0001W        $0006W       $0040W   $0000W
               $11C409BCRL $11C40A0DRL  $090B17DCRL       $2914W

#Red's shot collision
%patch $32B00 $11C4193BRL #Robo Red's shot
%patch $32B1E $11C4193BRL #Robo Red's shot


#Animations
#Robo Red shoot
%patch $32A92 $0194W $0193W
%patch $32AB0 $0194W $0193W
%patch $32ACE $0194W $0193W

#Robo Red's shot
%patch $32AEC $0191W $0191W
%patch $32B0A $0191W $0191W


#Robo Red's shot smash
%patch $32B28 $0192W $0192W
%patch $32B46 $0192W $0192W

#After shooting
%patch $126B1 $2914W #Spirogrip move


%patch $126EE $C7 $47 $18 $0000W $EB $10 #Red's shots only move horizontally

#Red doesn't jiggle back and forth when shooting:
%patch $32ABC $0000W		#Remove pushback in shooting anim, compensate by also removing
%patch $12718 $00 $00		#Right movement when facing right
%patch $1271D $00 $00		#Left movement when facing left

#Shot spawn relative to Red:
%patch $126CE $0050W #2 tiles down from sprite top
%patch $126BD $00D0W #3.5 tiles right, when shooting left only

#Number of shots
%patch $12643 $0001W #When Keen lands near Red (10)
%patch $12680 $0001W #When shot by Keen (10)

#Shikadi

#original Robo Red
#%patch $32A74  $0184W $0183W  $0000W       $0000W $0001W        $0006W       $0040W   $0000W
#               $11C409BCRL  $11C40A0DRL  $090B17DCRL       $2734W

#Shikadi Stand
#%patch $33050  $0140W $0140W  $0000W       $0000W     $0001W        $0045W       $0000W   $0000W
#               $00000000L  $11C41403RL  $11C41538RL       $2E00W


##########
# Sparky #
##########

#Prepare to charge cycle (skip that)
%patch $323D0 $210AW #Sparky prepare to charge


###########
# Shelley #
###########

%patch $11AB6 $5F $5E $5D $CB #Shelley push Keen, don't explode
%patch $11ADF $10 #Shelley don't explode when shot by Keen

#Shelly walk
%patch $32756 $01B0W $01ACW $0000W $0000W $0001W $0008W $0080W $0000W
	      $00000000L $11020A7CRL $090B17DCRL $2434W


%patch $32774 $01B1W $01ADW $0000W $0000W $0001W $0008W $0080W $0000W
	      $00000000L $11020A7CRL $090B17DCRL $2452W


%patch $32792 $01B2W $01AEW $0000W $0000W $0001W $0008W $0080W $0000W
	      $00000000L $11020A7CRL $090B17DCRL $2470W


%patch $327B0 $01B3W $01AFW $0000W $0000W $0001W $0008W $0080W $0000W
	      $00000000L $11020A7CRL $090B17DCRL $2416W


###########
# Shikadi #
###########

#Shelley don't jump off platform edges
%patch $119B7 $90 $90

#shikadi standing animation has zapping sprites
%patch $33050 $0145W $0144W $0000W $0000W $0001W $0010W $0000W $0000W
	      $090B1710RL $11C41403RL $11C41538RL $2D88W


#Shelley jumping animation is now shikadi standing animation
%patch $327CE  $0144W $0145W
%patch $327EC  $0142W $0140W
%patch $3280A  $0142W $0140W
%patch $32828  $0143W $0141W


#Shelly Smashing Animation is now standing
%patch $32846 $0145W $0144W $0000W $0000W $0001W $0008W $0000W $0000W
	      $00000000L $11C41403RL $11C41538RL $2D88W #Shelly smash A
%patch $32864 $0145W $0144W $0000W $0000W $0001W $0008W $0000W $0000W
	      $00000000L $11C41403RL $11C41538RL $2D88W #Shelly smash B


#Shikadi behavour
%patch $3309C $11C412ECRL #seek keen when waiting
%patch $330BA $11C412ECRL

#walking Shikadi
%patch $330C8 $014CW $0148W  $0000W $0000W $0001W $0008W $0080W $0000W
	      $11C412ECRL $11C41403RL $11C41538RL $2DA6W

%patch $330E6 $014DW $0149W  $0000W $0000W $0001W $0008W $0080W $0000W
	      $11020986RL $11C41403RL $11C41538RL $2DC4W

%patch $33104 $014EW $014AW  $0000W $0000W $0001W $0008W $0080W $0000W
	      $11020986RL $11C41403RL $11C41538RL $2DE2W

%patch $33122 $014FW $014BW  $0000W $0000W $0001W $0008W $0080W $0000W
	      $11020986RL $11C41403RL $11C41538RL $2D88W


#Shelley Jump Collossion
%patch $327E2 $11C41403RL #Shelley walk (Prepare)
%patch $32800 $11C41403RL #Shelley walk (Jump)
%patch $3281E $11C41403RL #Shelley walk (Flip)
%patch $3283C $11C41403RL #Shelley walk (Fall

#Shelley Smash A
%patch $32862 $2D10W
#Shelley Smash B
%patch $32880 $2D10W

#Produce these when smashed
%patch $11B3F $0000W #Shelly smash smoke
%patch $11A5A $0000W #Spawn Shelley right fragment
%patch $11A8D $0000W #Spawn Shelley left fragment
%patch $3289E $0000W

#Strength
%patch $12EFA $0004W

#Shelley jump right
%patch $119DA $0020W #Width
%patch $119DF $FFC0W #Height

#Shelley jump left
%patch $11A03 $FFDFW #Width
%patch $11A08 $FFC0W #Height


#Shelley jump right if Keen is:
%patch $119CF $7E    #At or further than...
%patch $119CD $0600W #6 tile right of it AND
%patch $119D5 $7D    #At or closer than...
%patch $119D3 $0900W #9 tiles right of it


#Shelley jump left if Keen is:
%patch $119F8 $7D    #At or further than...
%patch $119F6 $FA00W #6 tile left of it AND
%patch $119FE $7E    #At or closer than...
%patch $119FC $F500W #9 tiles left of it

#%patch $327EC  $014CW $0148W  $0000W $0001W $0001W $0001W $0000W $0000W 
#	      $110209FARL $11C41403RL $090B17B5RL $24ACW

#%patch $32828  $014CW $0148W  $0000W $0001W $0001W $0001W $0000W $0000W 
#	      $110209FARL $11C41403RL $090B17B5RL $24E8W


########################
# Vitalin - Ship Parts #
########################

#What Kegs increase
%patch $C102 $6F58W


#################
# Status Window #
#################

%patch $308E8 "ITEMS" $00
%patch $30917 "PARTS" $00


################
# Yorp Statues #
################

#Q.E.D\Fuse appears on all levels

%patch $F10C $90 $90

#Q.E.D\Fuse action - invisible

%patch $334C6 $FFFFW $FFFFW $0001W $00000000L $0008W $0000W $0000W
              $00000000L    $0AAF1FB7RL       $00000000L    $3186W
#K1n9_Duk3 mod: removed the draw function

#Q.E.D\Fuse collision, if Keen touches not on level 15 play sound 3, do window, vanish

%patch $CAA7 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $24
             $83 $3E $9E55W  $0F $74 $1D $B8 $0003W  $50 $9A $196E09EFRL
             $83 $C4 $02 $9A $06B9018BRL     $9A $174E0D56RL
             $56 $9A $06B91E47RL     $5F
             $5F $5E $5D $CB
#K1n9_Duk3 fix: remove object instead of setting its state to NULL

#Fuse window, 4 messages, cache 5 bitmaps

%patch $6D1B  $55 $8B $EC $9A $196E0AFBRL     $B8 $2B7BRW $8A $16 $EC $6F $8E
              $C0 $26 $08 $16 $002CW  $8E $C0 $26 $08 $16 $002DW  $8E $C0 $26
              $08 $16 $002EW  $8E $C0 $26 $08 $16 $002FW  $8E $C0 $26 $08 $16
              $005BW  $33 $C0 $50 $9A $13A01848RL     $83 $C4 $02 $9A $1E000995RL
                      $B8 $0008W  $50 $B8 $001AW  $50 $9A $1A2B106ERL     $83
              $C4 $04 $83 $3E $6F68W  $06 $75 $1C $83 $2E $99 $9B $30 $B8 $002EW
                  $50 $FF $36 $46 $9E $A1 $9B $9B $03 $06 $99 $9B $50 $9A $1E000C75RL
                          $EB $60 $83 $3E $6F68W  $09 $75 $1C $83 $2E $99 $9B
              $30 $B8 $002CW  $50 $FF $36 $46 $9E $A1 $9B $9B $03 $06 $99 $9B
              $50 $9A $1E000C75RL     $EB $3D $83 $3E $6F68W  $02 $75 $1C $83
              $2E $99 $9B $30 $B8 $002FW  $50 $FF $36 $46 $9E $A1 $9B $9B $03
              $06 $99 $9B $50 $9A $1E000C75RL     $EB $1A $83 $2E $99 $9B $30
              $B8 $002DW  $50 $FF $36 $46 $9E $A1 $9B $9B $03 $06 $99 $9B $50
%patch $6DEB  $9A $1E000C75RL $83 $C4 $06 $83 $06 $9D $9B $0C $83 $3E $6F68W
                  $06 $75 $0E $B8 $3766W  $50 $9A $1A2B0EBBRL     $83 $C4 $02
              $EB $36 $83 $3E $6F68W  $09 $75 $0E $B8 $37C1W  $50 $9A $1A2B0EBBRL
                      $83 $C4 $02 $EB $21 $83 $3E $6F68W  $02 $75 $0E $B8 $37F8W
                  $50 $9A $1A2B0EBBRL     $83 $C4 $02 $EB $0C
              $B8 $18BBW  $50 $9A $1A2B0EBBRL     $83 $C4 $02 $9A $1E000A97RL
                  $B8 $001EW  $50 $9A $1F030ADFRL     $83 $C4 $02 $9A $155A08A5RL
                  $9A $155A0EDCRL $B8 $005BW  $50 $FF $36 $46 $9E $A1 $9B $9B
              $03 $06 $99 $9B $50 $9A $1E000C75RL     $83 $C4 $06 $9A $1E000A97RL
                  $B8 $001EW  $50 $9A $1F030ADFRL     $83 $C4 $02 $9A $155A08A5RL
              $9A $155A0EDCRL     $5D $CB

#Level 6

%patch $33AA6 "The teleporter in" $0A 
	      "the ice will send" $0A
              "you to the dark" $0A
              "side of Mars." $0A $00
              

#Level 9

%patch $33B01 "There's a hidden city." $0A  $0A
              "Look in the south!" $00
              
              	                
#Level 2

%patch $33B38 "It is too bad that" $0A
              "you cannot read the" $0A
              "Standard Galactic" $0A
              "Alphabet, human." $00

#Any other level

%patch $31BFB "You will need a" $0A
              "Raygun in the end," $0A
              "but not to shoot" $0A
              "the Vorticon..." $00

##########
# Levels #
##########

#First elevator shaft doesn't care where Keen is on map
%patch $F431 $90 $90


%patch $30605 "Exit to Mars" $00

#Level names
%patch $20040 "Mars" $00
              "Border Town" $00
              "Red Rock Shrine" $00
              "Treasury" $00
%patch $2006A "Capital City" $00
              "Pogo Shrine" $00
              "Second Red Rock Shrine" $00
              "Emerald City" $00
%patch $200A7 "Ice City" $00
              "Third Red Rock Shrine" $00
              "First Ice Shrine" $00
              "Fourth Red Rock Shrine" $00
%patch $200EE "Fifth Red Rock Shrine" $00
              "Red Maze City" $00
              "Secret City" $00
              "High Scores" $00
%patch $2012A "Ice Shrine" $00
              "Vorticon Commander's" $0A "Castle" $00

#Level name pointers
%patch $31AB4 $20000040RL #Mars
              $20000045RL #Border Town
              $20000051RL #Red Rock Shrine
              $20000061RL #Treasury
%patch $31AC4 $2000006ARL #Capital City
              $20000077RL #Pogo Shrine
              $20000083RL #Second Red Rock Shrine
              $2000009ARL #Emerald City
%patch $31AD4 $200000A7RL #Ice City
              $200000B0RL #Third Red Rock Shrine
              $200000C6RL #First Ice Shrine
              $200000D7RL #Fourth Red Rock Shrine
%patch $31AE4 $200000EERL #Fifth Red Rock Shrine
              $20000104RL #Red Maze City
              $20000112RL #Secret City
              $2000011ERL #High Scores
%patch $31AF4 $2000012ARL #Ice Shrine
              $20000135RL #Vorticon Commander's_Castle



#Level entry texts
%patch $20151 "Keen explores" $0A "Mars" $00
              "Keen bursts into" $0A "the Border Town" $00
              "Keen visits the" $0A "First Red Rock Shrine" $00
              "Keen robs the" $0A "Treasury" $00
%patch $201C2 "Keen travels to" $0A "the Capital City" $00
              "Keen prays in the" $0A "Pogo Shrine" $00
              "Keen crawls through the" $0A "Second Red Rock Shrine" $00
              "Keen sees his reflections" $0A "in the Emerald City" $00
%patch $2025E "Keen slides through" $0A "the Ice City" $00
              "Keen trots into the" $0A "Third Red Rock Shrine" $00
              "Keen shivers along the" $0A "First Ice Shrine" $00
              "Keen strides into the" $0A "Fourth Red Rock Shrine" $00
%patch $202FE "Keen marches into the" $0A "Fifth Red Rock Shrine" $00
              "Keen finds his way" $0A "through the" $0A "Red Maze City" $00
              "Keen investigates the" $0A "Secret City" $00
              "Keen enters the" $0A "High Scores" $00
%patch $20395 "Keen slips through the" $0A "Second Ice Shrine" $00
              "Keen bursts into the" $0A "Vorticon Commander's" $0A "Castle" $00

#Level entry pointers
%patch $31B18 $20000151RL #Keen explores_Mars
              $20000164RL #Keen bursts into_the Border Town
              $20000185RL #Keen visits the_First Red Rock Shrine
              $200001ABRL #Keen robs the_Treasury
%patch $31B28 $200001C2RL #Keen travels to_the Capital City
              $200001E3RL #Keen prays in the_Pogo Shrine
              $20000201RL #Keen crawls through the_Second Red Rock Shrine
              $20000230RL #Keen sees his reflections_in the Emerald City
%patch $31B38 $2000025ERL #Keen slides through_the Ice City
              $2000027FRL #Keen trots into the_Third Red Rock Shrine
              $200002A9RL #Keen shivers along the_First Ice Shrine
              $200002D1RL #Keen strides into the_Fourth Red Rock Shrine
%patch $31B48 $200002FERL #Keen marches into the_Fifth Red Rock Shrine
              $2000032ARL #Keen finds his way_through the_Red Maze City
              $20000357RL #Keen investigates the_Secret City
              $20000379RL #Keen enters the_High Scores
%patch $31B58 $20000395RL #Keen slips through the_Second Ice Shrine
              $200003BERL #Keen bursts into the_Vorticon Commander's_Castle


#Scrolling Story
%patch $1FDE0 "Commander Keen" $0A
"Marooned on Mars" $0A $0A
"Billy Blaze, eight year-old" $0A
"genius has created an" $0A
"interstellar starship." $0A $0A
"When he dons his brothers" $0A
"football helmet he " $0A
"transforms into..." $0A $0A
"COMMANDER KEEN" $0A 
"Defender of Earth!" $0A $00
#Allow 24 levels in Keen 5 v1.4:

#First increase the number of levels we can access from the map to maximum (+6)

%patch $D2C2 $18 #Number of levels enterable ($18 = 24)

%patch $8C20 $18 #Number of level song entries (24, see below)


#Terminator text palette:
%patch $304F8 $00 $02 $02 $12 $01 $01 $01 $01     #Dark colors
              $11 $11 $11 $11 $13 $13 $13 $13 $00 #Light colors (and border color)

#Terminator text palette 2, screen moves out:
%patch $30509 $00 $02 $02 $12 $01 $01 $01 $01     #Dark colors
              $11 $11 $11 $11 $13 $13 $13 $02 $00 #Light colors (and border color)

# Demo

#List length
%patch $3C05 $02


#Main menu actions list

%patch $3CB3 $0442W #3C12: Terminator sequence and title screen
%patch $3CB5 $0466W #3C36: Star wars story
%patch $3CB7 $047BW #3C4B: High score demo

#Keenwave patch file; Patch sounds Keen 5:
%patchfile $21C80 AUDIOHED.CK5	#Audio header
%patchfile $35EC4 AUDIODCT.CK5	#Audio dictionary

#This is the music played in each level:
#             VALUE   LEVEL                      MUSIC PLAYED            LEVEL No
#192 = 0 Marooned
#193 = 1 Blake Stone - Freedom
#194 = 2 Corridor 7 - L1 Var 
#195 = 3 Tight +Fit
#196 = 4 Breath control
#197 = 5 Clean Sweep - BlueGasMask
#198 = 6 Major Stryker - Torpedo
#199 = 7 Blake Stone - Jungle
#200 = 8 Major Stryker - Soaring dizzy hights #
#201 = 9 Blake Stone - Gene Funk
#202 = A Blake Stone - Hiding
#203 = B Cosmo - Devo #
#204 = C Bio Menace - Crusing
#205 = D Bio Menace - Bayou
%patch $3067A $0000W  #Mars                      0
              $0001W  #Border Town              1
              $0002W  #Shrine 1                 2
              $0003W  #Treasury                 3
              $0004W  #Capital City             4
              $0005W  #Shrine Pogo              5
              $0006W  #Shrine 2                 6
              $0007W  #Emerald                  7
              $0008W  #Ice City                 8
              $0009W  #Shrine 3                 9
              $000AW  #Shrine Ice 1            10
              $000BW  #Shrine 4                11
              $000CW  #Shrine 5                12
              $000DW  #Maze                    13
              $000CW  #Ending                    (Fanfare)
              $0002W  #High Scores               (High Scores)             15
%patch $3069C $0001W  #Scrolling Story           (Armageddon Machine)
              $0000W  #Game Over                 (Came In)
              $0008W  #Help    


#Win game if Keen has four ship parts (That is, has won their levels, 4,8,17)
%patch $79F6 $83 $3E $6F22W  $00 $74 $57 $83 $3E $6F24W  $00 $74 $50 $83 $3E
             $6F2CW  $00 $74 $49 $83 $3E $6F3EW  $00 $74 $42 $83 $3E $9E55W
             $00 $75 $3B $C7 $06 $6F70W  $000FW  $EB $33

#######################
# K1n9_Duk3 Additions #
#######################

#Disable Sprite Test function (its code has been overwritten)
%patch $6CEE $CB	# turn first instruction into "retf"

#Disable Sprindred Think function (its code has been overwritten)
%patch $128E6 $CB	# turn first instruction into "retf"

#Shelley/Butler doesn't change state when hit by enemy shots
%patch $11AEE $90 $90
%patch $11AE3 $75 $0B

#Only remove level entrances for finished levels on world map
#(leave elevator and teleporter coordinates intact):
%patch $60C1
	$80 $7E $FB $C0		#	cmp	byte ptr [bp-5], 0C0h
	$75 $0D			#	jne	check_barrier
	$90 $90 $90 $90		#	nop nop nop nop

%patch $60D3 $90 $80 $7E $FB $D0	# modified barrier check
%patch $60EA $90 $80 $7E $FB $F0	# modified flag check


#never display the exit text screen (it's the default Keen 5 one anyway):
%patch $3A9F $EB

#use customized startup screen:
%patchfile $20CD7 INTROSCN.RSD

#Disable pogo for Gravis gamepad controls when player doesn't have a pogostick:
%patch $8AC6
	$A1 $BCA7w
	$A3 $BC29w
	$A1 $BCA5w
	$83 $3E $6F5Aw $00
	$74 $03
	$A3 $BC2Dw
	$33 $C0
	$3B $06 $BC31w
	$75 $03
	$A3 $BC2Fw
	$3B $06 $BC2Dw
	$75 $03
	$A3 $BC2Bw
	$3B $06 $BC29w
	$75 $03
	$A3 $BC27w
	$5D $CB


################################################################################
# Customized Screen Update Code For KEEN5 v1.4 (EGA)
# Copyright (c) 2019 K1n9_Duk3
#
# This software is provided 'as-is', without any express or implied warranty. In
# no event will the authors be held liable for any damages arising from the use
# of this software.
#
# Permission is granted to anyone to use this software for any purpose, including
# commercial applications, and to alter it and redistribute it freely, subject to
# the following restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not claim
#    that you wrote the original software. If you use this software in a product,
#    an acknowledgment in the product documentation would be appreciated but is
#    not required.
#
# 2. Altered source versions must be plainly marked as such, and must not be
#    misrepresented as being the original software.
#
# 3. This notice may not be removed or altered from any source distribution.
################################################################################

#replace the v1.4 delay code with my custom VW_SetScreen code
#(my VW_SetScreen is bigger than the one in v1.4)
%patch $1F795
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$BA $03DAw		#	mov	dx, 3DAh
	$FA			#	cli
				#@l1:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$74 $FB			#	jz	@l1
				#@l2:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$75 $FB			#	jnz	@l2
	$8B $4E $06		#	mov	cx, [bp+arg_start]
	$BA $03D4w		#	mov	dx, 3D4h
	$B0 $0C			#	mov	al, 0Ch
	$EE			#	out	dx, al
	$42			#	inc	dx
	$8A $C5			#	mov	al, ch
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$B0 $0D			#	mov	al, 0Dh
	$EE			#	out	dx, al
	$8A $C1			#	mov	al, cl
	$42			#	inc	dx
	$EE			#	out	dx, al
	$F7 $06 $6F12w $0001w	#	test	fixjerky, 1
	$74 $03			#	jz	@l3
	$E8 $0053w		#	call	WaitVBL
				#@l3:
	$F7 $06 $6FDEw $0001w	#	test	nopan, 1
	$75 $0C			#	jnz	l4
	$BA $03C0w		#	mov	dx, 3C0h
	$B0 $33			#	mov	al, 33h
	$EE			#	out	dx, al
	$EB $00			#	jmp	$
	$8A $46 $08		#	mov	al, [bp+arg_pan]
	$EE			#	out	dx, al
				#@l4:
	$F7 $06 $6F12w $0001w	#	test	fixjerky, 1
	$75 $03			#	jnz	@l5
	$E8 $0034w		#	call	WaitVBL
				#@l5:
	$FB			#	sti
	$5D			#	pop	bp
	$CB			#	retf

#replace the start of VW_SetScreen with a jump into my new code (see above):
%patch $1F816
	$E9 $FF7Cw

#and overwrite the rest of the old VW_SetScreen code with my WaitVBL code:
	$8B $1E $9BA5w		#	mov	bx, word ptr TimeCount
	$BA $03DAw		#	mov	dx, 3DAh
				#@wait:	
	$FB			#	sti
	$EB $00			#	jmp	short $
	$FA			#	cli
	$EC			#	in	al, dx
	$A8 $08			#	test	al, 8
	$75 $0A			#	jnz	@done
	$A1 $9BA5w		#	mov	ax, word ptr TimeCount
	$2B $C3			#	sub	ax, bx
	$3D $0001w		#	cmp	ax, 1
	$76 $ED			#	jbe	@wait
				#@done:
	$C3			#	retn

################################################################################
# End of Customized Screen Update Code
################################################################################

##############################
# Load Audio Chunks Directly #
##############################

# This patch forces the game to load the audio data directly from the file into
# the final buffer without doing any Huffman decompression. This requires the
# AUDIO.CK5 file to be compressed with a "dummy" Huffman dictionary.
#
# Without this code, the game would load the "compressed" data into a temporary
# buffer and then decompress it into the final buffer. That means the memory
# requirements for music are more than TWICE(!) the size of the IMF song.

%patch $14403
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $76	$FE		#	push	bp+var_2
	$FF $76 $FC		#	push	bp+var_4
	$FF $36 $C2CBw		#	push	audiohandle
	$9A $00001BC9rl		#	call	_lseek
	$83 $C4 $08		#	add	sp, 8
	$B8 $0004w		#	mov	ax, 4
	$50			#	push	ax
	$B8 $C2C3w		#	mov	ax, offset chunkexplen
	$50			#	push	ax
	$FF $36 $C2CBw		#	push	audiohandle
	$9A $00001F10rl		#	call	_read
	$83 $C4 $06		#	add	sp, 6
	$FF $36 $C2C5w		#	push	word ptr chunkexplen+2
	$FF $36 $C2C3w		#	push	word ptr chunkexplen
	$8B $C6			#	mov	ax, si
	$D1 $E0			#	shl	ax, 1
	$05 $BDC5w		#	add	ax, offset audiosegs
	$50			#	push	ax
	$9A $1657071Frl		#	call	MM_GetPtr
	$83 $C4 $06		#	add	sp, 6
	$83 $3E $9E57w $00	#	cmp	mmerror, 0
	$75 $1E			#	jnz	done
	$FF $36 $C2C5w		#	push	word ptr chunkexplen+2
	$FF $36 $C2C3w		#	push	word ptr chunkexplen
	$8B $DE			#	mov	bx, si
	$D1 $E3			#	shl	bx, 1
	$FF $B7 $BDC5w		#	push	audiosegs[bx]
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $36 $C2CBw		#	push	audiohandle
	$0E			#	push	cs
	$E8 $F68Bw		#	call	near ptr CA_FarRead
	$83 $C4 $0A		#	add	sp, 10
				#done:
	$5E			#	pop	si
	$8B $E5			#	mov	sp, bp
	$5D			#	pop	bp
	$CB			#	retf

# This leaves 183 bytes unused at $1446E to $14524 (inclusive)

# With this code, the huffman tree for the audio data is no longer needed,
# so let's prevent the engine from "optimizing" the huffman tree. This frees
# up 1024 bytes in the data segment, great for adding new (near) strings or
# new object state definitions.

# Free up 1024 bytes at $35EC4 (dseg:5B84):
%patch $14310 $EB $0F


########################################################
# Free Tile And Sprite Graphics Before Loading A Level #
########################################################

#Free sprites and tiles before loading a level
%patch $6179
	$74 $0A			#	jz	no_demo
	$C7 $06 $6F6Cw $0002w	#	mov	gamestate_difficulty, 2
	$33 $C0			#	xor	ax, ax
	$EB $03			#	jmp	init_rndt
				#no_demo:
	$B8 $0001w		#	mov	ax, 1
				#init_rndt:
	$50			#	push	ax
	$9A $1DFB000Erl		#	call	US_InitRndT
	$58			#	pop	ax
	$9A $05C1000Arl		#	call	FreeUpMemory
	$90 $90 $90 $90 $90 $90	#	(6x nop)

#Don't free the paddle war sprites (in case loading a game fails)
%patch $5C1F $006Bw		# default: $0066w
	
##################
# Memory Related #
##################

# Fix error in XMS size calculation
%patch $1675F
	$BB $0010w		#	mov	bx, 16
	$F7 $E3			#	mul	bx
	$01 $06 $967Fw		#	add	..., ax
	$11 $16 $9681w		#	adc	..., dx


# Lock text buffers to avoid "PageLayout: Text not headed with ^P" error

# CacheAndLock routine (returns grsegs offset in AX):
%patch $19731
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$57			#	push	di
	$8B $7E $06		#	mov	di, [bp+arg_0]
	$57			#	push	di
	$9A $13A01114rl		#	call	CA_CacheGrChunk
	$58			#	pop	ax
	$B8 $0001w		#	mov	ax, 1
	$50			#	push	ax
	$D1 $E7			#	shl	di, 1
	$81 $C7 $6FEDw		#	add	di, offset grsegs
	$57			#	push	di
	$9A $16570AE2rl		#	call	MM_SetLock
	$83 $C4 $04		#	add	sp, 4
	$8B $C7			#	mov	ax, di
	$5F			#	pop	di
	$5D			#	pop	bp
	$CB			#	retf
# Note: this overwrites the unused SDL_TimingService code (2 bytes left unused)

# Use CacheAndLock and make sure to free the memory at the end
%patch $EB21 $196E0051rl	# for the help texts
%patch $EC3B $196E0051rl $83 $C4 $02 $8B $F8 $8B $05	# for the secret ending
%patch $EC4D $196E0051rl $83 $C4 $02 $8B $F8 $8B $05	# for the normal ending
%patch $EC58 $90 $A3		# for both ending texts
%patch $ED11 $EB $03 $90 $90 $90 $57	# for both ending texts
%patch $ED1F $90 $90		# for both ending texts


# Make CA_UpLevel flow into CA_ClearMarks so we don't load more	than we need
%patch $14EE8 $EB $30



%end